sqlplus oracloid/me <<!

DROP TABLE ctl;

CREATE TABLE ctl (
  inst_id NUMBER,
  fname VARCHAR2(30),
  delay NUMBER NOT NULL,
  PRIMARY KEY (inst_id,fname)
);

INSERT INTO ctl VALUES (1,'NewOrder',0.05);
INSERT INTO ctl VALUES (2,'NewOrder',0.05);
INSERT INTO ctl VALUES (3,'NewOrder',0.05);
INSERT INTO ctl VALUES (1,'Delivery',0.1);
INSERT INTO ctl VALUES (2,'Delivery',0.1);
INSERT INTO ctl VALUES (3,'Delivery',0.1);
COMMIT;

DROP TABLE orders;
CREATE TABLE orders (
entry_date date not null
);

create or replace FUNCTION GETDELAY
( afname IN VARCHAR2
) RETURN NUMBER AS
  ldelay number;
BEGIN
  SELECT delay INTO ldelay FROM ctl where fname=afname and inst_id=(SELECT instance_number from v\$instance);
  RETURN ldelay;
EXCEPTION
WHEN NO_DATA_FOUND THEN
    RETURN ldelay;
END GETDELAY;
/
show errors

create or replace PROCEDURE DELAY
( sec IN NUMBER
) AS
 i NUMBER;
 dummy NUMBER;
BEGIN
  FOR i in 1..sec*50 LOOP
    dummy := dummy+cos(i)+sin(i);
  END LOOP;
  DBMS_LOCK.SLEEP(sec);
END DELAY;
/
show errors

create or replace PROCEDURE NEWORDER AS
 dummy date;
BEGIN
  DBMS_APPLICATION_INFO.SET_ACTION('NewOrder');
  select sysdate into dummy from dual;
  DELAY(GETDELAY('NewOrder'));
  insert into orders VALUES (SYSDATE);
  COMMIT;
  DBMS_APPLICATION_INFO.SET_ACTION('');
END NEWORDER;
/
show errors

create or replace PROCEDURE DELIVERY AS
  dummy date;
BEGIN
  DBMS_APPLICATION_INFO.SET_ACTION('Delivery');
  select sysdate into dummy from dual;
  DELAY(GETDELAY('Delivery'));
  DELETE FROM ORDERS WHERE ROWNUM<=(SELECT COUNT(*)/2 FROM orders);
  COMMIT;
  DBMS_APPLICATION_INFO.SET_ACTION('');
END DELIVERY;
/
show errors

!
